/* Specification
Barbara Williams
Created/Revised on October 13, 2010
Ch. 13 Lab 7
This lab writes a program which consists of two classes; a cashRegister class and a 
dispenserType class. The derived class is called dispenserType with all the necessary 
function definitions and constructors to make the class functional. The program 
includes a test program (main) to test the member functions of each of the classes
by creating dispenserType objects and then performing the necessary operations to test
all possible behavior. Using sound construction techniques and design principles,
the code was manipulated into separate header and implementation files for better reuse 
and modularity. The sellProduct() function keeps prompting the user until enough money 
is entered and then returns any excess.*/

#include <iostream>			//required by cout command
#include "cashRegister.h"	//cashRegister header file - Required by class
#include "dispenserType.h"	//dispenserType header file - Required by class

//Default namespace defining library functions (e.g. cout, endl)
using namespace std;

//stand alone function for displaying selection menu
void showSelection()
{
	cout << "*** Welcom to Shelly's Candy Shop ***" << endl;
	cout << "To select an item, enter " << endl;
	cout << "1 for Candy" << endl;
	cout << "2 for Chips" << endl;
	cout << "3 for Gum" << endl;
	cout << "4 for Cookies" << endl;
	cout << "9 to exit" << endl;
	
}	//end showSelection

//stand alone function for sellProduct function
void sellProduct(dispenserType& product, cashRegister& pCounter)
{
	//variable to hold the amount entered
	int amount;
	
	//variable to hold the extra amount needed
	int amount2;
	
	//if the dispenser is not empty
	if (product.getNoOfItems() > 0)
	{
		cout << "\nPlease deposit " << product.getCost()
			<< " cents" << endl;
		cin >> amount;
		
		//while money deposited less than product cost
		while (amount < product.getCost())
		{
			cout << "\nPlease deposit another "
				<< product.getCost() - amount
				<< " cents" << endl;
			cin >> amount2;
			amount = amount + amount2;
		}
		
		//if amount deposited equals product cost
		if (amount == product.getCost()
		{
			pCounter.acceptAmount(amount);
			product.makeSale();
			cout << "\nCollect your item at the bottom and enjoy.\n" << endl;
				
		}
		
		//if amount deposited is more than product cost 
		if (amount > product.getCost())
		{
			//calculate and display difference
			cout << "\nYour change of " 
				<< amount - product.getCost()
				<< " cents is below." << endl;
			cout << endl;
			
			//accept money and make sale
			pCounter.acceptAmount(amount);
			product.makeSale();
			cout << "Collect your item at the bottom and enjoy.\n" << endl;
		}
	}
	
	//if item out of stock
	else
		cout << "Sorry, this item is sold out." << endl;
		
}	//end sellProduct

int main()
{
	//instantiate counter and objects
	cashRegister counter;
	dispenserType candy(100, 50);
	dispenserType chips(100, 65);
	dispenserType gum(75, 45);
	dispenserType cookies(100, 85);
	
	//variable to hold the selection
	int choice;
	
	//call showSelection function
	showSelection();
	cin >> choice;
	
	//while choice selection is not "9"
	while(choice !=9)
	{
		switch(choice)
		{
			case 1:
				sellProduct(candy, counter);
			break;
			
			case 2:
				sellProduct(chips, counter);
			break;
			
			case 3:
				sellProduct(gum, counter);
			break;
			
			case 4:
				sellProduct(cookies, counter);
			break;
			
			default:
				cout << "Invalid selection." << endl;
		
		}	//end switch
		
		//display showSelection function
		showSelection();
		cin >> choice;
		
	}	//end while statement
	
	return 0;
	
}	//end main