/* Specification
Barbara Williams
Created/Revised on October 13, 2010
Ch. 13 Lab 7
This lab writes a program which consists of two classes; a cashRegister class and a 
dispenserType class. The derived class is called dispenserType with all the necessary 
function definitions and constructors to make the class functional. The program 
includes a test program (main) to test the member functions of each of the classes
by creating dispenserType objects and then performing the necessary operations to test
all possible behavior. Using sound construction techniques and design principles,
the code was manipulated into separate header and implementation files for better reuse 
and modularity. The sellProduct() function keeps prompting the user until enough money 
is entered and then returns any excess.*/

// cashRegister.cpp, the implementation file of the parent class.

// cashRegister header file - Required by class
#include "cashRegister.h"

/**********************************
* cashRegister method definitions *
**********************************/

/* An accessor method called getCurrentBalance that takes one parameter and returns an
integer. Function is to return the cashOnHand.*/
int cashRegister::getCurrentBalance() const
{
	return cashOnHand;
	
}	//end getCurrentBalance function

/* A mutator method called acceptAmount to increase the cashOnHand. Function is to add
amountIn to cashOnHand.*/
void cashRegister::acceptAmount(int amountIn)
{
	//adds amountIn to cashOnHand
	cashOnHand = cashOnHand + amountIn;
	
}	//end acceptAmount function

// overloaded constructor that takes one parameter
cashRegister::cashRegister(int cashIn)
{
	//checks and sets cashOnHand
	if (cashIn >= 0)
		cashOnHand = cashIn;
	else
		cashOnHand = 500;
		
}	//end constructor with parameter