/* Specification
Barbara Williams
Created/Revised on October 13, 2010
Ch. 13 Lab 7
This lab writes a program which consists of two classes; a cashRegister class and a 
dispenserType class. The derived class is called dispenserType with all the necessary 
function definitions and constructors to make the class functional. The program 
includes a test program (main) to test the member functions of each of the classes
by creating dispenserType objects and then performing the necessary operations to test
all possible behavior. Using sound construction techniques and design principles,
the code was manipulated into separate header and implementation files for better reuse 
and modularity. The sellProduct() function keeps prompting the user until enough money 
is entered and then returns any excess.*/

/* cashRegister.h the specification file for the class cashRegister contains three public
member functions and one private integer member variable.*/

//a preprocessor identifier means "if not defined CASHREGISTER_H"
#ifndef CASHREGISTER_H

//a preprocessor identifier means "defined CASHREGISTER_H"
#define CASHREGISTER_H

//Required by cout command
#include <iostream>	

//Date header file - Required by class
#include "dispenserType.h"

//Default namespace defining library functions (e.g. cout, endl)
using namespace std;

/********************************
* cashRegister class definition *
********************************/

class cashRegister
{
	public:
		/*Function to show the current amount in the cash register.
		Postcondition: The value of cashOnHand is returned.*/
		int getCurrentBalance() const;
		
		/*Function to receive the amount deposited by the customer
		and update the amount in the register. Postcondition: 
		cashOnHand = cashOnHand + amountIn*/
		void acceptAmount(int amountIn);
		
		/*Constructor - sets the cash in the register to a specific
		amount. Postcondition: cashOnHand = cashIn
		If no value is specified when the object is declared, the
		default value assigned to cashOnHand is 500.*/
		cashRegister(int cashIn = 500);
		
	private:
		//variable to store the cash in the register
		int cashOnHand;
};

//a preprocessor identifier means "end if"
#endif
