/* Specification
Barbara Williams
Created/Revised on October 13, 2010
Ch. 13 Lab 7
This lab writes a program which consists of two classes; a cashRegister class and a 
dispenserType class. The derived class is called dispenserType with all the necessary 
function definitions and constructors to make the class functional. The program 
includes a test program (main) to test the member functions of each of the classes
by creating dispenserType objects and then performing the necessary operations to test
all possible behavior. Using sound construction techniques and design principles,
the code was manipulated into separate header and implementation files for better reuse 
and modularity. The sellProduct() function keeps prompting the user until enough money 
is entered and then returns any excess.*/

/* dispenserType.cpp, the implementation file of the dervived class. The user program
that uses parent cashRegister class.*/

// dispenserType header file - Required by class
#include "dispenserType.h"

/***********************************
* dispenserType method definitions *
***********************************/

/* An accessor method called getNoOfItems that takes one parameter and returns an 
integer. Function is to return the numberOfItems.*/
int dispenserType::getNoOfItems() const
{
	return numberOfItems;
	
}	//end getNoOfItems

/* An accessor method called getCost that takes one parameter and returns and 
integer.Function is to return the cost.*/
int dispenserType::getCost() const
{
	return cost;
	
}	//end getCost

// A mutator method called makeSale to decrement the item.
void dispenserType::makeSale()
{
	//decreases numberOfItems by one digit
	numberOfItems--;
	
}	//end makeSale function

// An overloaded constructor with parameters.
dispenserType::dispenserType(int setNoOfItems, int setCost)
{
	//checks and sets number of items available
	if (setNoOfItems >= 0)
		numberOfItems = setNoOfItems;
	else
		numberOfItems = 50;
		
	// checks and sets the cost of items
	if (setCost >= 0)
		cost = setCost;
	else
		cost = 50;
	
}	//end constructor with parameters