/* Specification
Barbara Williams
Created/Revised on October 13, 2010
Ch. 13 Lab 7
This lab writes a program which consists of two classes; a cashRegister class and a 
dispenserType class. The derived class is called dispenserType with all the necessary 
function definitions and constructors to make the class functional. The program 
includes a test program (main) to test the member functions of each of the classes
by creating dispenserType objects and then performing the necessary operations to test
all possible behavior. Using sound construction techniques and design principles,
the code was manipulated into separate header and implementation files for better reuse 
and modularity. The sellProduct() function keeps prompting the user until enough money 
is entered and then returns any excess.*/

/* dispenserType.h the specification file for the class dispenserType contains four
public member functions and one private integer member variable.*/

//a preprocessor identifier means "if not defined DISPENSERTYPE_H"
#ifndef DISPENSERTYPE_H

//a preprocessor identifier means "defined DISPENSERTYPE_H"
#define DISPENSERTYPE_H

//Required by cout command
#include "cashRegister.h"

/*********************************
* dispenserType class definition *
*********************************/

class dispenserType
{
	public:
		/*Function to show the number of items in the machine. Postcondition: The
		value of numberOfItems is returned.*/
		int getNoOfItems() const;
		
		/*Function to show the cost of the item. Postcondition: The value of cost 
		is returned.*/
		int getCost() const;
		
		//Function to reduce the number of items by 1. Postcondition: numberOfItems--;
		void makeSale();
		
		/*Constructor - Sets the cost and number of items in the dispenser to the
		values specified by the user. Postcondition: numberOfItems = setNoOfItems;
		cost = setCost;   If no value is specified for a parameter, then its default
		value is assigned to the corresponding member variable.*/
		dispenserType(int setNoOfItems = 50, int setCost = 50);
		
	private:
		//variable to store the number of items in the dispenser
		int numberOfItems;
		
		//variable to store the cost of an item
		int cost;
};

//	a preprocessor identifier means "end if"
#endif

		